#ifndef _HATP_OPRS_LEXER_H
#define _HATP_OPRS_LEXER_H

using namespace std;

// ---------- Default parsing ----------
static const string OSPACE		= "[[:space:]]";
static const string OWORD		= "([[:word:]]+)";
static const string OLPAREN		= "[(]";
static const string ORPAREN		= "[)]";
static const string OLLIST		= "[(.][[.period.]]" + OSPACE;
static const string ORLIST		= "[[.period.]][)]";
static const string OCLIST		= "(([[:word:]]+\\s)*)";
static const string OLIST		= OLLIST + OCLIST + ORLIST;

// ---------- OPRS parsing ----------

static const string O_HATPREQ	= "HATP-REQ";
static const string O_REQTYPE	= "REQ-TYPE";
static const string O_REQID		= "REQ-ID";
static const string O_TASKNAME	= "TASK-NAME";
static const string O_PARAMS	= "PARAMETERS";

static const string OREQTYPE 	= OLPAREN + O_REQTYPE + OSPACE + OWORD + ORPAREN;
static const string OREQID		= OLPAREN + O_REQID + OSPACE + OWORD + ORPAREN;
static const string OTASKNAME	= OLPAREN + O_TASKNAME + OSPACE + OWORD + ORPAREN;
static const string OPARAMS		= OLPAREN + O_PARAMS + OSPACE + OLIST + ORPAREN;

static const string HATPREQ 	= OLPAREN + O_HATPREQ + OSPACE + OREQTYPE + OSPACE + OREQID + OSPACE + OTASKNAME + OSPACE + OPARAMS + ORPAREN;

#endif
